// Copyright 2024 Matthew Rich <matthewrich.conf@gmail.com>. All rights reserved.

package codec

import (
_	"fmt"
	"github.com/stretchr/testify/assert"
_	"log"
	"testing"
)

type TestDec struct {
	FormatType Format `yaml:"formattype" json:"formattype"`
}

func TestFormatType(t *testing.T) {
	yamlData := `
formattype: json
`
	v := &TestDec{}

	dec := NewYAMLStringDecoder(yamlData)
	e := dec.Decode(v)

	assert.Nil(t, e)

	assert.Equal(t, FormatJson, v.FormatType)
}

func TestFormatTypeErr(t *testing.T) {
	yamlData := `
formattype: foo
`

	v := &TestDec{}

	dec := NewYAMLStringDecoder(yamlData)
	e := dec.Decode(v)

	assert.ErrorIs(t, ErrInvalidFormat, e)
}
